/* Generated automatically -- do not modify!    -*- buffer-read-only: t -*- */

#include <config.h>
#include "lib/ovn-ic-nb-idl.h"
#include <limits.h>
#include "ovs-thread.h"
#include "ovsdb-data.h"
#include "ovsdb-error.h"
#include "util.h"





static struct icnbrec_connection *
icnbrec_connection_cast(const struct ovsdb_idl_row *row)
{
    return row ? CONTAINER_OF(row, struct icnbrec_connection, header_) : NULL;
}

static struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_cast(const struct ovsdb_idl_row *row)
{
    return row ? CONTAINER_OF(row, struct icnbrec_ic_nb_global, header_) : NULL;
}

static struct icnbrec_ssl *
icnbrec_ssl_cast(const struct ovsdb_idl_row *row)
{
    return row ? CONTAINER_OF(row, struct icnbrec_ssl, header_) : NULL;
}

static struct icnbrec_transit_switch *
icnbrec_transit_switch_cast(const struct ovsdb_idl_row *row)
{
    return row ? CONTAINER_OF(row, struct icnbrec_transit_switch, header_) : NULL;
}

/* Connection table. */

bool
icnbrec_server_has_connection_table_col_external_ids(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_external_ids);
}


bool
icnbrec_server_has_connection_table_col_inactivity_probe(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_inactivity_probe);
}


bool
icnbrec_server_has_connection_table_col_is_connected(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_is_connected);
}


bool
icnbrec_server_has_connection_table_col_max_backoff(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_max_backoff);
}


bool
icnbrec_server_has_connection_table_col_other_config(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_other_config);
}


bool
icnbrec_server_has_connection_table_col_status(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_status);
}


bool
icnbrec_server_has_connection_table_col_target(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_connection_col_target);
}


bool
icnbrec_server_has_connection_table(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_table(idl, &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
}


const struct icnbrec_connection_table *
icnbrec_connection_table_get(const struct ovsdb_idl *idl)
{
    return (const struct icnbrec_connection_table *) idl;
}

const struct icnbrec_connection *
icnbrec_connection_table_first(const struct icnbrec_connection_table *table)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_connection_first(idl);
}


const struct icnbrec_connection *
icnbrec_connection_table_track_get_first(const struct icnbrec_connection_table *table)
{
    const struct ovsdb_idl *idl =  (const struct ovsdb_idl *) table;
    return icnbrec_connection_track_get_first(idl);
}


static void
icnbrec_connection_parse_external_ids(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    smap_init(&row->external_ids);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->external_ids,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_connection_parse_inactivity_probe(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    size_t n = MIN(1, datum->n);
    row->inactivity_probe = NULL;
    row->n_inactivity_probe = 0;
    for (size_t i = 0; i < n; i++) {
        if (!row->n_inactivity_probe) {
            row->inactivity_probe = xmalloc(n * sizeof *row->inactivity_probe);
        }
        row->inactivity_probe[row->n_inactivity_probe] = datum->keys[i].integer;
        row->n_inactivity_probe++;
    }
}

static void
icnbrec_connection_parse_is_connected(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);

    if (datum->n >= 1) {
        row->is_connected = datum->keys[0].boolean;
    } else {
        row->is_connected = false;
    }
}

static void
icnbrec_connection_parse_max_backoff(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    size_t n = MIN(1, datum->n);
    row->max_backoff = NULL;
    row->n_max_backoff = 0;
    for (size_t i = 0; i < n; i++) {
        if (!row->n_max_backoff) {
            row->max_backoff = xmalloc(n * sizeof *row->max_backoff);
        }
        row->max_backoff[row->n_max_backoff] = datum->keys[i].integer;
        row->n_max_backoff++;
    }
}

static void
icnbrec_connection_parse_other_config(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    smap_init(&row->other_config);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->other_config,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_connection_parse_status(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    smap_init(&row->status);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->status,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_connection_parse_target(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);

    if (datum->n >= 1) {
        row->target = datum->keys[0].s->string;
    } else {
        row->target = "";
    }
}

static void
icnbrec_connection_unparse_external_ids(struct ovsdb_idl_row *row_)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    smap_destroy(&row->external_ids);
}

static void
icnbrec_connection_unparse_inactivity_probe(struct ovsdb_idl_row *row_)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    free(row->inactivity_probe);
}

static void
icnbrec_connection_unparse_is_connected(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_connection_unparse_max_backoff(struct ovsdb_idl_row *row_)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    free(row->max_backoff);
}

static void
icnbrec_connection_unparse_other_config(struct ovsdb_idl_row *row_)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    smap_destroy(&row->other_config);
}

static void
icnbrec_connection_unparse_status(struct ovsdb_idl_row *row_)
{
    struct icnbrec_connection *row = icnbrec_connection_cast(row_);
    smap_destroy(&row->status);
}

static void
icnbrec_connection_unparse_target(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_connection_init__(struct ovsdb_idl_row *row)
{
    icnbrec_connection_init(icnbrec_connection_cast(row));
}

/* Clears the contents of 'row' in table "Connection". */
void
icnbrec_connection_init(struct icnbrec_connection *row)
{
    memset(row, 0, sizeof *row); 
    smap_init(&row->external_ids);
    smap_init(&row->other_config);
    smap_init(&row->status);
    row->target = "";
}

/* Searches table "Connection" in 'idl' for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_connection *
icnbrec_connection_get_for_uuid(const struct ovsdb_idl *idl, const struct uuid *uuid)
{
    return icnbrec_connection_cast(ovsdb_idl_get_row_for_uuid(idl, &icnbrec_table_connection, uuid));
}

/* Searches table "Connection" for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_connection *
icnbrec_connection_table_get_for_uuid(const struct icnbrec_connection_table *table, const struct uuid *uuid)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_connection_get_for_uuid(idl, uuid);
}

/* Returns a row in table "Connection" in 'idl', or a null pointer if that
 * table is empty.
 *
 * Database tables are internally maintained as hash tables, so adding or
 * removing rows while traversing the same table can cause some rows to be
 * visited twice or not at apply. */
const struct icnbrec_connection *
icnbrec_connection_first(const struct ovsdb_idl *idl)
{
    return icnbrec_connection_cast(ovsdb_idl_first_row(idl, &icnbrec_table_connection));
}

/* Returns a row following 'row' within its table, or a null pointer if 'row'
 * is the last row in its table. */
const struct icnbrec_connection *
icnbrec_connection_next(const struct icnbrec_connection *row)
{
    return icnbrec_connection_cast(ovsdb_idl_next_row(&row->header_));
}

unsigned int icnbrec_connection_get_seqno(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_table_get_seqno(idl, &icnbrec_table_connection);
}

unsigned int icnbrec_connection_row_get_seqno(const struct icnbrec_connection *row, enum ovsdb_idl_change change)
{
    return ovsdb_idl_row_get_seqno(&row->header_, change);
}

const struct icnbrec_connection *
icnbrec_connection_track_get_first(const struct ovsdb_idl *idl)
{
    return icnbrec_connection_cast(ovsdb_idl_track_get_first(idl, &icnbrec_table_connection));
}

const struct icnbrec_connection
*icnbrec_connection_track_get_next(const struct icnbrec_connection *row)
{
    return icnbrec_connection_cast(ovsdb_idl_track_get_next(&row->header_));
}


/* Deletes 'row' from table "Connection".  'row' may be freed, so it must not be
 * accessed afterward.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_delete(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_delete(&row->header_);
}

/* Inserts and returns a new row in the table "Connection" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned a randomly generated provisional UUID.
 * ovsdb-server will assign a different UUID when 'txn' is committed,
 * but the IDL will replace any uses of the provisional UUID in the
 * data to be to be committed by the UUID assigned by ovsdb-server. */
struct icnbrec_connection *
icnbrec_connection_insert(struct ovsdb_idl_txn *txn)
{
    return icnbrec_connection_cast(ovsdb_idl_txn_insert(txn, &icnbrec_table_connection, NULL));
}

/* Inserts and returns a new row in the table "Connection" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned the UUID specified in the 'uuid' parameter
 * (which cannot be null).  ovsdb-server will try to assign the same
 * UUID when 'txn' is committed. */
struct icnbrec_connection *
icnbrec_connection_insert_persist_uuid(struct ovsdb_idl_txn *txn, const struct uuid *uuid)
{
    return icnbrec_connection_cast(ovsdb_idl_txn_insert_persist_uuid(
        txn, &icnbrec_table_connection, uuid));
}

bool
icnbrec_connection_is_updated(const struct icnbrec_connection *row, enum icnbrec_connection_column_id column)
{
    return ovsdb_idl_track_is_updated(&row->header_, &icnbrec_connection_columns[column]);
}

/* Causes the original contents of column "external_ids" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "external_ids" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "external_ids" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "external_ids" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "external_ids" has already been modified (with
 *     icnbrec_connection_set_external_ids()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_external_ids() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_external_ids(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_external_ids);
}

/* Causes the original contents of column "inactivity_probe" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "inactivity_probe" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "inactivity_probe" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "inactivity_probe" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "inactivity_probe" has already been modified (with
 *     icnbrec_connection_set_inactivity_probe()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_inactivity_probe() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_inactivity_probe(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_inactivity_probe);
}

/* Causes the original contents of column "is_connected" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "is_connected" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "is_connected" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "is_connected" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "is_connected" has already been modified (with
 *     icnbrec_connection_set_is_connected()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_is_connected() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_is_connected(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_is_connected);
}

/* Causes the original contents of column "max_backoff" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "max_backoff" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "max_backoff" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "max_backoff" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "max_backoff" has already been modified (with
 *     icnbrec_connection_set_max_backoff()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_max_backoff() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_max_backoff(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_max_backoff);
}

/* Causes the original contents of column "other_config" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "other_config" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "other_config" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "other_config" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "other_config" has already been modified (with
 *     icnbrec_connection_set_other_config()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_other_config() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_other_config(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_other_config);
}

/* Causes the original contents of column "status" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "status" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "status" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "status" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "status" has already been modified (with
 *     icnbrec_connection_set_status()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_status() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_status(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_status);
}

/* Causes the original contents of column "target" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "target" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "target" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "target" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_connection_insert()).
 *
 *   - If "target" has already been modified (with
 *     icnbrec_connection_set_target()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_connection_set_target() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_connection_verify_target(const struct icnbrec_connection *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_connection_col_target);
}

/* Returns the "external_ids" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes external_ids's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "external_ids" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_external_ids(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_external_ids);
}

/* Returns the "inactivity_probe" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_INTEGER.
 * (This helps to avoid silent bugs if someone changes inactivity_probe's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "inactivity_probe" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_inactivity_probe(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_INTEGER);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_inactivity_probe);
}

/* Returns the "is_connected" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_BOOLEAN.
 * (This helps to avoid silent bugs if someone changes is_connected's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "is_connected" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_is_connected(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_BOOLEAN);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_is_connected);
}

/* Returns the "max_backoff" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_INTEGER.
 * (This helps to avoid silent bugs if someone changes max_backoff's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "max_backoff" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_max_backoff(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_INTEGER);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_max_backoff);
}

/* Returns the "other_config" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes other_config's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "other_config" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_other_config(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_other_config);
}

/* Returns the "status" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes status's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "status" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_status(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_status);
}

/* Returns the "target" column's value from the "Connection" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes target's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "target" member in icnbrec_connection. */
const struct ovsdb_datum *
icnbrec_connection_get_target(const struct icnbrec_connection *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_connection_col_target);
}

/* Sets the "external_ids" column's value from the "Connection" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_connection_set_external_ids(const struct icnbrec_connection *row, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_connection_col_external_ids,
                        &datum);
}


/* Sets the "inactivity_probe" column from the "Connection" table in 'row' to
 * the 'inactivity_probe' set with 'n_inactivity_probe' entries.
 *
 * 'n_inactivity_probe' may be 0 or 1; if it is 0, then 'inactivity_probe'
 * may be NULL.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_set_inactivity_probe(const struct icnbrec_connection *row, const int64_t *inactivity_probe, size_t n_inactivity_probe)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    if (n_inactivity_probe) {
        union ovsdb_atom *key = xmalloc(sizeof *key);
        datum.n = 1;
        datum.keys = key;
        key->integer = *inactivity_probe;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_connection_col_inactivity_probe, &datum);
}

/* Sets the "is_connected" column from the "Connection" table in 'row' to
 * 'is_connected'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_set_is_connected(const struct icnbrec_connection *row, bool is_connected)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->boolean = is_connected;
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_connection_col_is_connected, &datum);
}

/* Sets the "max_backoff" column from the "Connection" table in 'row' to
 * the 'max_backoff' set with 'n_max_backoff' entries.
 *
 * 'n_max_backoff' may be 0 or 1; if it is 0, then 'max_backoff'
 * may be NULL.
 *
 * Argument constraints: at least 1,000
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_set_max_backoff(const struct icnbrec_connection *row, const int64_t *max_backoff, size_t n_max_backoff)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    if (n_max_backoff) {
        union ovsdb_atom *key = xmalloc(sizeof *key);
        datum.n = 1;
        datum.keys = key;
        key->integer = *max_backoff;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_connection_col_max_backoff, &datum);
}

/* Sets the "other_config" column's value from the "Connection" table in 'row'
 * to 'other_config'.
 *
 * The caller retains ownership of 'other_config' and everything in it. */
void
icnbrec_connection_set_other_config(const struct icnbrec_connection *row, const struct smap *other_config)
{
    struct ovsdb_datum datum;

    if (other_config) {
        ovsdb_datum_from_smap(&datum, other_config);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_connection_col_other_config,
                        &datum);
}


/* Sets the "status" column's value from the "Connection" table in 'row'
 * to 'status'.
 *
 * The caller retains ownership of 'status' and everything in it. */
void
icnbrec_connection_set_status(const struct icnbrec_connection *row, const struct smap *status)
{
    struct ovsdb_datum datum;

    if (status) {
        ovsdb_datum_from_smap(&datum, status);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_connection_col_status,
                        &datum);
}


/* Sets the "target" column from the "Connection" table in 'row' to
 * 'target'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_set_target(const struct icnbrec_connection *row, const char *target)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(target);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_connection_col_target, &datum);
}

/* Sets an element of the "external_ids" map column from the "Connection" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_connection_update_external_ids_setkey(const struct icnbrec_connection *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_connection_col_external_ids,
                                    datum);
}

/* Deletes an element of the "external_ids" map column from the "Connection" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_connection_update_external_ids_delkey(const struct icnbrec_connection *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_connection_col_external_ids,
                                    datum);
}

/* Adds the value 'new_value' to the "inactivity_probe" set column from the "Connection" table
 * in 'row'.
 *
 */
void
icnbrec_connection_update_inactivity_probe_addvalue(const struct icnbrec_connection *row, int64_t new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].integer = new_value;

    ovsdb_idl_txn_write_partial_set(&row->header_,
                                    &icnbrec_connection_col_inactivity_probe,
                                    datum);
}

/* Deletes the value 'delete_value' from the "inactivity_probe" set column from the
 * "Connection" table in 'row'.
 *
 */
void
icnbrec_connection_update_inactivity_probe_delvalue(const struct icnbrec_connection *row, int64_t delete_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].integer = delete_value;

    ovsdb_idl_txn_delete_partial_set(&row->header_,
                                    &icnbrec_connection_col_inactivity_probe,
                                    datum);
}

/* Adds the value 'new_value' to the "max_backoff" set column from the "Connection" table
 * in 'row'.
 *
 */
void
icnbrec_connection_update_max_backoff_addvalue(const struct icnbrec_connection *row, int64_t new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].integer = new_value;

    ovsdb_idl_txn_write_partial_set(&row->header_,
                                    &icnbrec_connection_col_max_backoff,
                                    datum);
}

/* Deletes the value 'delete_value' from the "max_backoff" set column from the
 * "Connection" table in 'row'.
 *
 */
void
icnbrec_connection_update_max_backoff_delvalue(const struct icnbrec_connection *row, int64_t delete_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].integer = delete_value;

    ovsdb_idl_txn_delete_partial_set(&row->header_,
                                    &icnbrec_connection_col_max_backoff,
                                    datum);
}

/* Sets an element of the "other_config" map column from the "Connection" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_connection_update_other_config_setkey(const struct icnbrec_connection *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_connection_col_other_config,
                                    datum);
}

/* Deletes an element of the "other_config" map column from the "Connection" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_connection_update_other_config_delkey(const struct icnbrec_connection *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_connection_col_other_config,
                                    datum);
}

/* Sets an element of the "status" map column from the "Connection" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_connection_update_status_setkey(const struct icnbrec_connection *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_connection_col_status,
                                    datum);
}

/* Deletes an element of the "status" map column from the "Connection" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_connection_update_status_delkey(const struct icnbrec_connection *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_connection_col_status,
                                    datum);
}

/* Sets the "external_ids" column's value from the "Connection" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_connection_add_clause_external_ids(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_connection_col_external_ids,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_external_ids.type);
}


/* Sets the "inactivity_probe" column from the "Connection" table in 'row' to
 * the 'inactivity_probe' set with 'n_inactivity_probe' entries.
 *
 * 'n_inactivity_probe' may be 0 or 1; if it is 0, then 'inactivity_probe'
 * may be NULL.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_add_clause_inactivity_probe(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const int64_t *inactivity_probe, size_t n_inactivity_probe)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    if (n_inactivity_probe) {
        union ovsdb_atom *key = xmalloc(sizeof *key);
        datum.n = 1;
        datum.keys = key;
        key->integer = *inactivity_probe;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_connection_col_inactivity_probe,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_inactivity_probe.type);
}

/* Sets the "is_connected" column from the "Connection" table in 'row' to
 * 'is_connected'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_add_clause_is_connected(struct ovsdb_idl_condition *cond, enum ovsdb_function function, bool is_connected)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->boolean = is_connected;
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_connection_col_is_connected,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_is_connected.type);
}

/* Sets the "max_backoff" column from the "Connection" table in 'row' to
 * the 'max_backoff' set with 'n_max_backoff' entries.
 *
 * 'n_max_backoff' may be 0 or 1; if it is 0, then 'max_backoff'
 * may be NULL.
 *
 * Argument constraints: at least 1,000
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_add_clause_max_backoff(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const int64_t *max_backoff, size_t n_max_backoff)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    if (n_max_backoff) {
        union ovsdb_atom *key = xmalloc(sizeof *key);
        datum.n = 1;
        datum.keys = key;
        key->integer = *max_backoff;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_connection_col_max_backoff,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_max_backoff.type);
}

/* Sets the "other_config" column's value from the "Connection" table in 'row'
 * to 'other_config'.
 *
 * The caller retains ownership of 'other_config' and everything in it. */
void
icnbrec_connection_add_clause_other_config(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *other_config)
{
    struct ovsdb_datum datum;

    if (other_config) {
        ovsdb_datum_from_smap(&datum, other_config);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_connection_col_other_config,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_other_config.type);
}


/* Sets the "status" column's value from the "Connection" table in 'row'
 * to 'status'.
 *
 * The caller retains ownership of 'status' and everything in it. */
void
icnbrec_connection_add_clause_status(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *status)
{
    struct ovsdb_datum datum;

    if (status) {
        ovsdb_datum_from_smap(&datum, status);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_connection_col_status,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_status.type);
}


/* Sets the "target" column from the "Connection" table in 'row' to
 * 'target'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_add_clause_target(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *target)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(target);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_connection_col_target,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_connection_col_target.type);
}

/* Destroy 'row' of kind "Connection". The row must have been
 * created with ovsdb_idl_index_init_row.
 */
void
icnbrec_connection_index_destroy_row(const struct icnbrec_connection *row)
{
    ovsdb_idl_index_destroy_row(&row->header_);
}
        

/* Creates a new row of kind "Connection". */
struct icnbrec_connection *
icnbrec_connection_index_init_row(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_connection);
    return ALIGNED_CAST(struct icnbrec_connection *, ovsdb_idl_index_init_row(index));
}

struct icnbrec_connection *
icnbrec_connection_index_find(struct ovsdb_idl_index *index, const struct icnbrec_connection *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_connection);
    return icnbrec_connection_cast(ovsdb_idl_index_find(index, &target->header_));
}

/* Compares 'a' to 'b' and returns a strcmp()-type result. */
int
icnbrec_connection_index_compare(
    struct ovsdb_idl_index *index, 
    const struct icnbrec_connection *a, 
    const struct icnbrec_connection *b)
{
    return ovsdb_idl_index_compare(index, &a->header_, &b->header_);
}

struct ovsdb_idl_cursor
icnbrec_connection_cursor_first(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_connection);
    return ovsdb_idl_cursor_first(index);
}

struct ovsdb_idl_cursor
icnbrec_connection_cursor_first_eq(
    struct ovsdb_idl_index *index, const struct icnbrec_connection *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_connection);
    return ovsdb_idl_cursor_first_eq(index, &target->header_);
}

struct ovsdb_idl_cursor
icnbrec_connection_cursor_first_ge(
    struct ovsdb_idl_index *index, const struct icnbrec_connection *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_connection);
    return ovsdb_idl_cursor_first_ge(index, target ? &target->header_ : NULL);
}

struct icnbrec_connection *
icnbrec_connection_cursor_data(struct ovsdb_idl_cursor *cursor)
{
    return icnbrec_connection_cast(ovsdb_idl_cursor_data(cursor));
}


/* Sets the "external_ids" column's value from the "Connection" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_connection_index_set_external_ids(const struct icnbrec_connection *row, const struct smap *external_ids)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (external_ids) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(external_ids);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, external_ids) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_connection_col_external_ids.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_connection_columns[ICNBREC_CONNECTION_COL_EXTERNAL_IDS],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
    free(datum);
}


/* Sets the "inactivity_probe" column from the "Connection" table in 'row' to
 * the 'inactivity_probe' set with 'n_inactivity_probe' entries.
 *
 * 'n_inactivity_probe' may be 0 or 1; if it is 0, then 'inactivity_probe'
 * may be NULL.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_index_set_inactivity_probe(const struct icnbrec_connection *row, const int64_t *inactivity_probe, size_t n_inactivity_probe)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key;

    if (n_inactivity_probe) {
        key = xmalloc(sizeof(union ovsdb_atom));
        datum.n = 1;
        datum.keys = key;
        key->integer = *inactivity_probe;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_connection_columns[ ICNBREC_CONNECTION_COL_INACTIVITY_PROBE ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
}

/* Sets the "is_connected" column from the "Connection" table in 'row' to
 * 'is_connected'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_index_set_is_connected(const struct icnbrec_connection *row, bool is_connected)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->boolean = is_connected;
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_connection_columns[ ICNBREC_CONNECTION_COL_IS_CONNECTED ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
}

/* Sets the "max_backoff" column from the "Connection" table in 'row' to
 * the 'max_backoff' set with 'n_max_backoff' entries.
 *
 * 'n_max_backoff' may be 0 or 1; if it is 0, then 'max_backoff'
 * may be NULL.
 *
 * Argument constraints: at least 1,000
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_index_set_max_backoff(const struct icnbrec_connection *row, const int64_t *max_backoff, size_t n_max_backoff)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key;

    if (n_max_backoff) {
        key = xmalloc(sizeof(union ovsdb_atom));
        datum.n = 1;
        datum.keys = key;
        key->integer = *max_backoff;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_connection_columns[ ICNBREC_CONNECTION_COL_MAX_BACKOFF ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
}

/* Sets the "other_config" column's value from the "Connection" table in 'row'
 * to 'other_config'.
 *
 * The caller retains ownership of 'other_config' and everything in it. */
void
icnbrec_connection_index_set_other_config(const struct icnbrec_connection *row, const struct smap *other_config)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (other_config) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(other_config);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, other_config) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_connection_col_other_config.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_connection_columns[ICNBREC_CONNECTION_COL_OTHER_CONFIG],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
    free(datum);
}


/* Sets the "status" column's value from the "Connection" table in 'row'
 * to 'status'.
 *
 * The caller retains ownership of 'status' and everything in it. */
void
icnbrec_connection_index_set_status(const struct icnbrec_connection *row, const struct smap *status)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (status) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(status);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, status) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_connection_col_status.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_connection_columns[ICNBREC_CONNECTION_COL_STATUS],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
    free(datum);
}


/* Sets the "target" column from the "Connection" table in 'row' to
 * 'target'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_connection_index_set_target(const struct icnbrec_connection *row, const char *target)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(target);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_connection_columns[ ICNBREC_CONNECTION_COL_TARGET ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_CONNECTION]);
}

struct ovsdb_idl_column icnbrec_connection_columns[ICNBREC_CONNECTION_N_COLUMNS];

unsigned int
icnbrec_connection_set_condition(struct ovsdb_idl *idl, struct ovsdb_idl_condition *condition)
{
    return ovsdb_idl_set_condition(idl, &icnbrec_table_connection, condition);
}

struct ovsdb_idl_column icnbrec_connection_columns[ICNBREC_CONNECTION_N_COLUMNS] = {
    [ICNBREC_CONNECTION_COL_EXTERNAL_IDS] = {
         .name = "external_ids",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_external_ids,
         .unparse = icnbrec_connection_unparse_external_ids,
    },

    [ICNBREC_CONNECTION_COL_INACTIVITY_PROBE] = {
         .name = "inactivity_probe",
         .type = {
            .key = {
               .type = OVSDB_TYPE_INTEGER,
               .integer = { .min = INT64_MIN, .max = INT64_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 0,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_inactivity_probe,
         .unparse = icnbrec_connection_unparse_inactivity_probe,
    },

    [ICNBREC_CONNECTION_COL_IS_CONNECTED] = {
         .name = "is_connected",
         .type = {
            .key = {
               .type = OVSDB_TYPE_BOOLEAN,
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_is_connected,
         .unparse = icnbrec_connection_unparse_is_connected,
    },

    [ICNBREC_CONNECTION_COL_MAX_BACKOFF] = {
         .name = "max_backoff",
         .type = {
            .key = {
               .type = OVSDB_TYPE_INTEGER,
               .integer = { .min = INT64_C(1000), .max = INT64_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 0,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_max_backoff,
         .unparse = icnbrec_connection_unparse_max_backoff,
    },

    [ICNBREC_CONNECTION_COL_OTHER_CONFIG] = {
         .name = "other_config",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_other_config,
         .unparse = icnbrec_connection_unparse_other_config,
    },

    [ICNBREC_CONNECTION_COL_STATUS] = {
         .name = "status",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_status,
         .unparse = icnbrec_connection_unparse_status,
    },

    [ICNBREC_CONNECTION_COL_TARGET] = {
         .name = "target",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_connection_parse_target,
         .unparse = icnbrec_connection_unparse_target,
    },

};

/* IC_NB_Global table. */

bool
icnbrec_server_has_ic_nb_global_table_col_connections(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ic_nb_global_col_connections);
}


bool
icnbrec_server_has_ic_nb_global_table_col_external_ids(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ic_nb_global_col_external_ids);
}


bool
icnbrec_server_has_ic_nb_global_table_col_nb_ic_cfg(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ic_nb_global_col_nb_ic_cfg);
}


bool
icnbrec_server_has_ic_nb_global_table_col_options(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ic_nb_global_col_options);
}


bool
icnbrec_server_has_ic_nb_global_table_col_sb_ic_cfg(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ic_nb_global_col_sb_ic_cfg);
}


bool
icnbrec_server_has_ic_nb_global_table_col_ssl(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ic_nb_global_col_ssl);
}


bool
icnbrec_server_has_ic_nb_global_table(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_table(idl, &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
}


const struct icnbrec_ic_nb_global_table *
icnbrec_ic_nb_global_table_get(const struct ovsdb_idl *idl)
{
    return (const struct icnbrec_ic_nb_global_table *) idl;
}

const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_table_first(const struct icnbrec_ic_nb_global_table *table)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_ic_nb_global_first(idl);
}


const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_table_track_get_first(const struct icnbrec_ic_nb_global_table *table)
{
    const struct ovsdb_idl *idl =  (const struct ovsdb_idl *) table;
    return icnbrec_ic_nb_global_track_get_first(idl);
}


static void
icnbrec_ic_nb_global_parse_connections(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);
    row->connections = NULL;
    row->n_connections = 0;
    for (size_t i = 0; i < datum->n; i++) {
        struct icnbrec_connection *keyRow = icnbrec_connection_cast(ovsdb_idl_get_row_arc(row_, &icnbrec_table_connection, &datum->keys[i].uuid));
        if (!keyRow) {
            continue;
        }
        if (!row->n_connections) {
            row->connections = xmalloc(datum->n * sizeof *row->connections);
        }
        row->connections[row->n_connections] = keyRow;
        row->n_connections++;
    }
}

static void
icnbrec_ic_nb_global_parse_external_ids(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);
    smap_init(&row->external_ids);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->external_ids,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_ic_nb_global_parse_nb_ic_cfg(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);

    if (datum->n >= 1) {
        row->nb_ic_cfg = datum->keys[0].integer;
    } else {
        row->nb_ic_cfg = 0;
    }
}

static void
icnbrec_ic_nb_global_parse_options(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);
    smap_init(&row->options);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->options,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_ic_nb_global_parse_sb_ic_cfg(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);

    if (datum->n >= 1) {
        row->sb_ic_cfg = datum->keys[0].integer;
    } else {
        row->sb_ic_cfg = 0;
    }
}

static void
icnbrec_ic_nb_global_parse_ssl(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);

    if (datum->n >= 1) {
        row->ssl = icnbrec_ssl_cast(ovsdb_idl_get_row_arc(row_, &icnbrec_table_ssl, &datum->keys[0].uuid));
    } else {
        row->ssl = NULL;
    }
}

static void
icnbrec_ic_nb_global_unparse_connections(struct ovsdb_idl_row *row_)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);
    free(row->connections);
}

static void
icnbrec_ic_nb_global_unparse_external_ids(struct ovsdb_idl_row *row_)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);
    smap_destroy(&row->external_ids);
}

static void
icnbrec_ic_nb_global_unparse_nb_ic_cfg(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ic_nb_global_unparse_options(struct ovsdb_idl_row *row_)
{
    struct icnbrec_ic_nb_global *row = icnbrec_ic_nb_global_cast(row_);
    smap_destroy(&row->options);
}

static void
icnbrec_ic_nb_global_unparse_sb_ic_cfg(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ic_nb_global_unparse_ssl(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ic_nb_global_init__(struct ovsdb_idl_row *row)
{
    icnbrec_ic_nb_global_init(icnbrec_ic_nb_global_cast(row));
}

/* Clears the contents of 'row' in table "IC_NB_Global". */
void
icnbrec_ic_nb_global_init(struct icnbrec_ic_nb_global *row)
{
    memset(row, 0, sizeof *row); 
    smap_init(&row->external_ids);
    smap_init(&row->options);
}

/* Searches table "IC_NB_Global" in 'idl' for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_get_for_uuid(const struct ovsdb_idl *idl, const struct uuid *uuid)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_get_row_for_uuid(idl, &icnbrec_table_ic_nb_global, uuid));
}

/* Searches table "IC_NB_Global" for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_table_get_for_uuid(const struct icnbrec_ic_nb_global_table *table, const struct uuid *uuid)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_ic_nb_global_get_for_uuid(idl, uuid);
}

/* Returns a row in table "IC_NB_Global" in 'idl', or a null pointer if that
 * table is empty.
 *
 * Database tables are internally maintained as hash tables, so adding or
 * removing rows while traversing the same table can cause some rows to be
 * visited twice or not at apply. */
const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_first(const struct ovsdb_idl *idl)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_first_row(idl, &icnbrec_table_ic_nb_global));
}

/* Returns a row following 'row' within its table, or a null pointer if 'row'
 * is the last row in its table. */
const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_next(const struct icnbrec_ic_nb_global *row)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_next_row(&row->header_));
}

unsigned int icnbrec_ic_nb_global_get_seqno(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_table_get_seqno(idl, &icnbrec_table_ic_nb_global);
}

unsigned int icnbrec_ic_nb_global_row_get_seqno(const struct icnbrec_ic_nb_global *row, enum ovsdb_idl_change change)
{
    return ovsdb_idl_row_get_seqno(&row->header_, change);
}

const struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_track_get_first(const struct ovsdb_idl *idl)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_track_get_first(idl, &icnbrec_table_ic_nb_global));
}

const struct icnbrec_ic_nb_global
*icnbrec_ic_nb_global_track_get_next(const struct icnbrec_ic_nb_global *row)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_track_get_next(&row->header_));
}


/* Deletes 'row' from table "IC_NB_Global".  'row' may be freed, so it must not be
 * accessed afterward.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_delete(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_delete(&row->header_);
}

/* Inserts and returns a new row in the table "IC_NB_Global" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned a randomly generated provisional UUID.
 * ovsdb-server will assign a different UUID when 'txn' is committed,
 * but the IDL will replace any uses of the provisional UUID in the
 * data to be to be committed by the UUID assigned by ovsdb-server. */
struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_insert(struct ovsdb_idl_txn *txn)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_txn_insert(txn, &icnbrec_table_ic_nb_global, NULL));
}

/* Inserts and returns a new row in the table "IC_NB_Global" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned the UUID specified in the 'uuid' parameter
 * (which cannot be null).  ovsdb-server will try to assign the same
 * UUID when 'txn' is committed. */
struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_insert_persist_uuid(struct ovsdb_idl_txn *txn, const struct uuid *uuid)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_txn_insert_persist_uuid(
        txn, &icnbrec_table_ic_nb_global, uuid));
}

bool
icnbrec_ic_nb_global_is_updated(const struct icnbrec_ic_nb_global *row, enum icnbrec_ic_nb_global_column_id column)
{
    return ovsdb_idl_track_is_updated(&row->header_, &icnbrec_ic_nb_global_columns[column]);
}

/* Causes the original contents of column "connections" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "connections" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "connections" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "connections" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ic_nb_global_insert()).
 *
 *   - If "connections" has already been modified (with
 *     icnbrec_ic_nb_global_set_connections()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ic_nb_global_set_connections() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_verify_connections(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ic_nb_global_col_connections);
}

/* Causes the original contents of column "external_ids" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "external_ids" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "external_ids" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "external_ids" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ic_nb_global_insert()).
 *
 *   - If "external_ids" has already been modified (with
 *     icnbrec_ic_nb_global_set_external_ids()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ic_nb_global_set_external_ids() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_verify_external_ids(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ic_nb_global_col_external_ids);
}

/* Causes the original contents of column "nb_ic_cfg" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "nb_ic_cfg" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "nb_ic_cfg" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "nb_ic_cfg" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ic_nb_global_insert()).
 *
 *   - If "nb_ic_cfg" has already been modified (with
 *     icnbrec_ic_nb_global_set_nb_ic_cfg()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ic_nb_global_set_nb_ic_cfg() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_verify_nb_ic_cfg(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ic_nb_global_col_nb_ic_cfg);
}

/* Causes the original contents of column "options" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "options" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "options" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "options" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ic_nb_global_insert()).
 *
 *   - If "options" has already been modified (with
 *     icnbrec_ic_nb_global_set_options()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ic_nb_global_set_options() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_verify_options(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ic_nb_global_col_options);
}

/* Causes the original contents of column "sb_ic_cfg" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "sb_ic_cfg" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "sb_ic_cfg" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "sb_ic_cfg" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ic_nb_global_insert()).
 *
 *   - If "sb_ic_cfg" has already been modified (with
 *     icnbrec_ic_nb_global_set_sb_ic_cfg()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ic_nb_global_set_sb_ic_cfg() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_verify_sb_ic_cfg(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ic_nb_global_col_sb_ic_cfg);
}

/* Causes the original contents of column "ssl" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "ssl" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "ssl" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "ssl" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ic_nb_global_insert()).
 *
 *   - If "ssl" has already been modified (with
 *     icnbrec_ic_nb_global_set_ssl()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ic_nb_global_set_ssl() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ic_nb_global_verify_ssl(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ic_nb_global_col_ssl);
}

/* Returns the "connections" column's value from the "IC_NB_Global" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_UUID.
 * (This helps to avoid silent bugs if someone changes connections's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "connections" member in icnbrec_ic_nb_global. */
const struct ovsdb_datum *
icnbrec_ic_nb_global_get_connections(const struct icnbrec_ic_nb_global *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_UUID);
    return ovsdb_idl_read(&row->header_, &icnbrec_ic_nb_global_col_connections);
}

/* Returns the "external_ids" column's value from the "IC_NB_Global" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes external_ids's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "external_ids" member in icnbrec_ic_nb_global. */
const struct ovsdb_datum *
icnbrec_ic_nb_global_get_external_ids(const struct icnbrec_ic_nb_global *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ic_nb_global_col_external_ids);
}

/* Returns the "nb_ic_cfg" column's value from the "IC_NB_Global" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_INTEGER.
 * (This helps to avoid silent bugs if someone changes nb_ic_cfg's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "nb_ic_cfg" member in icnbrec_ic_nb_global. */
const struct ovsdb_datum *
icnbrec_ic_nb_global_get_nb_ic_cfg(const struct icnbrec_ic_nb_global *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_INTEGER);
    return ovsdb_idl_read(&row->header_, &icnbrec_ic_nb_global_col_nb_ic_cfg);
}

/* Returns the "options" column's value from the "IC_NB_Global" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes options's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "options" member in icnbrec_ic_nb_global. */
const struct ovsdb_datum *
icnbrec_ic_nb_global_get_options(const struct icnbrec_ic_nb_global *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ic_nb_global_col_options);
}

/* Returns the "sb_ic_cfg" column's value from the "IC_NB_Global" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_INTEGER.
 * (This helps to avoid silent bugs if someone changes sb_ic_cfg's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "sb_ic_cfg" member in icnbrec_ic_nb_global. */
const struct ovsdb_datum *
icnbrec_ic_nb_global_get_sb_ic_cfg(const struct icnbrec_ic_nb_global *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_INTEGER);
    return ovsdb_idl_read(&row->header_, &icnbrec_ic_nb_global_col_sb_ic_cfg);
}

/* Returns the "ssl" column's value from the "IC_NB_Global" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_UUID.
 * (This helps to avoid silent bugs if someone changes ssl's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "ssl" member in icnbrec_ic_nb_global. */
const struct ovsdb_datum *
icnbrec_ic_nb_global_get_ssl(const struct icnbrec_ic_nb_global *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_UUID);
    return ovsdb_idl_read(&row->header_, &icnbrec_ic_nb_global_col_ssl);
}

/* Sets the "connections" column from the "IC_NB_Global" table in 'row' to
 * the 'connections' set with 'n_connections' entries.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_set_connections(const struct icnbrec_ic_nb_global *row, struct icnbrec_connection **connections, size_t n_connections)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    datum.n = n_connections;
    datum.keys = n_connections ? xmalloc(n_connections * sizeof *datum.keys) : NULL;
    datum.values = NULL;
    for (size_t i = 0; i < n_connections; i++) {
        datum.keys[i].uuid = connections[i]->header_.uuid;
    }
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ic_nb_global_col_connections, &datum);
}

/* Sets the "external_ids" column's value from the "IC_NB_Global" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_ic_nb_global_set_external_ids(const struct icnbrec_ic_nb_global *row, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_ic_nb_global_col_external_ids,
                        &datum);
}


/* Sets the "nb_ic_cfg" column from the "IC_NB_Global" table in 'row' to
 * 'nb_ic_cfg'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_set_nb_ic_cfg(const struct icnbrec_ic_nb_global *row, int64_t nb_ic_cfg)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->integer = nb_ic_cfg;
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ic_nb_global_col_nb_ic_cfg, &datum);
}

/* Sets the "options" column's value from the "IC_NB_Global" table in 'row'
 * to 'options'.
 *
 * The caller retains ownership of 'options' and everything in it. */
void
icnbrec_ic_nb_global_set_options(const struct icnbrec_ic_nb_global *row, const struct smap *options)
{
    struct ovsdb_datum datum;

    if (options) {
        ovsdb_datum_from_smap(&datum, options);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_ic_nb_global_col_options,
                        &datum);
}


/* Sets the "sb_ic_cfg" column from the "IC_NB_Global" table in 'row' to
 * 'sb_ic_cfg'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_set_sb_ic_cfg(const struct icnbrec_ic_nb_global *row, int64_t sb_ic_cfg)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->integer = sb_ic_cfg;
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ic_nb_global_col_sb_ic_cfg, &datum);
}

/* Sets the "ssl" column from the "IC_NB_Global" table in 'row' to
 * the 'ssl' set.
 *
 * If "ssl" is null, the column will be the empty set,
 * otherwise it will contain the specified value.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_set_ssl(const struct icnbrec_ic_nb_global *row, const struct icnbrec_ssl *ssl)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    if (ssl) {
        union ovsdb_atom *key = xmalloc(sizeof *key);
        datum.n = 1;
        datum.keys = key;
        key->uuid = ssl->header_.uuid;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ic_nb_global_col_ssl, &datum);
}

/* Adds the value 'new_value' to the "connections" set column from the "IC_NB_Global" table
 * in 'row'.
 *
 */
void
icnbrec_ic_nb_global_update_connections_addvalue(const struct icnbrec_ic_nb_global *row, const struct icnbrec_connection *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].uuid = new_value->header_.uuid;

    ovsdb_idl_txn_write_partial_set(&row->header_,
                                    &icnbrec_ic_nb_global_col_connections,
                                    datum);
}

/* Deletes the value 'delete_value' from the "connections" set column from the
 * "IC_NB_Global" table in 'row'.
 *
 */
void
icnbrec_ic_nb_global_update_connections_delvalue(const struct icnbrec_ic_nb_global *row, const struct icnbrec_connection *delete_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].uuid = delete_value->header_.uuid;

    ovsdb_idl_txn_delete_partial_set(&row->header_,
                                    &icnbrec_ic_nb_global_col_connections,
                                    datum);
}

/* Sets an element of the "external_ids" map column from the "IC_NB_Global" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_ic_nb_global_update_external_ids_setkey(const struct icnbrec_ic_nb_global *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_ic_nb_global_col_external_ids,
                                    datum);
}

/* Deletes an element of the "external_ids" map column from the "IC_NB_Global" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_ic_nb_global_update_external_ids_delkey(const struct icnbrec_ic_nb_global *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_ic_nb_global_col_external_ids,
                                    datum);
}

/* Sets an element of the "options" map column from the "IC_NB_Global" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_ic_nb_global_update_options_setkey(const struct icnbrec_ic_nb_global *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_ic_nb_global_col_options,
                                    datum);
}

/* Deletes an element of the "options" map column from the "IC_NB_Global" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_ic_nb_global_update_options_delkey(const struct icnbrec_ic_nb_global *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_ic_nb_global_col_options,
                                    datum);
}

/* Adds the value 'new_value' to the "ssl" set column from the "IC_NB_Global" table
 * in 'row'.
 *
 */
void
icnbrec_ic_nb_global_update_ssl_addvalue(const struct icnbrec_ic_nb_global *row, const struct icnbrec_ssl *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].uuid = new_value->header_.uuid;

    ovsdb_idl_txn_write_partial_set(&row->header_,
                                    &icnbrec_ic_nb_global_col_ssl,
                                    datum);
}

/* Deletes the value 'delete_value' from the "ssl" set column from the
 * "IC_NB_Global" table in 'row'.
 *
 */
void
icnbrec_ic_nb_global_update_ssl_delvalue(const struct icnbrec_ic_nb_global *row, const struct icnbrec_ssl *delete_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->values);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].uuid = delete_value->header_.uuid;

    ovsdb_idl_txn_delete_partial_set(&row->header_,
                                    &icnbrec_ic_nb_global_col_ssl,
                                    datum);
}

/* Sets the "connections" column from the "IC_NB_Global" table in 'row' to
 * the 'connections' set with 'n_connections' entries.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_add_clause_connections(struct ovsdb_idl_condition *cond, enum ovsdb_function function, struct uuid **connections, size_t n_connections)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    datum.n = n_connections;
    datum.keys = n_connections ? xmalloc(n_connections * sizeof *datum.keys) : NULL;
    datum.values = NULL;
    for (size_t i = 0; i < n_connections; i++) {
        datum.keys[i].uuid = *connections[i];
    }
    ovsdb_datum_sort_unique(&datum, &icnbrec_ic_nb_global_col_connections.type);
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ic_nb_global_col_connections,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ic_nb_global_col_connections.type);
}

/* Sets the "external_ids" column's value from the "IC_NB_Global" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_ic_nb_global_add_clause_external_ids(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_ic_nb_global_col_external_ids,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_ic_nb_global_col_external_ids.type);
}


/* Sets the "nb_ic_cfg" column from the "IC_NB_Global" table in 'row' to
 * 'nb_ic_cfg'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_add_clause_nb_ic_cfg(struct ovsdb_idl_condition *cond, enum ovsdb_function function, int64_t nb_ic_cfg)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->integer = nb_ic_cfg;
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ic_nb_global_col_nb_ic_cfg,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ic_nb_global_col_nb_ic_cfg.type);
}

/* Sets the "options" column's value from the "IC_NB_Global" table in 'row'
 * to 'options'.
 *
 * The caller retains ownership of 'options' and everything in it. */
void
icnbrec_ic_nb_global_add_clause_options(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *options)
{
    struct ovsdb_datum datum;

    if (options) {
        ovsdb_datum_from_smap(&datum, options);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_ic_nb_global_col_options,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_ic_nb_global_col_options.type);
}


/* Sets the "sb_ic_cfg" column from the "IC_NB_Global" table in 'row' to
 * 'sb_ic_cfg'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_add_clause_sb_ic_cfg(struct ovsdb_idl_condition *cond, enum ovsdb_function function, int64_t sb_ic_cfg)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->integer = sb_ic_cfg;
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ic_nb_global_col_sb_ic_cfg,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ic_nb_global_col_sb_ic_cfg.type);
}

/* Sets the "ssl" column from the "IC_NB_Global" table in 'row' to
 * the 'ssl' set.
 *
 * If "ssl" is null, the column will be the empty set,
 * otherwise it will contain the specified value.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_add_clause_ssl(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct uuid *ssl)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    if (ssl) {
        union ovsdb_atom *key = xmalloc(sizeof *key);
        datum.n = 1;
        datum.keys = key;
        key->uuid = *ssl;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ic_nb_global_col_ssl,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ic_nb_global_col_ssl.type);
}

/* Destroy 'row' of kind "IC_NB_Global". The row must have been
 * created with ovsdb_idl_index_init_row.
 */
void
icnbrec_ic_nb_global_index_destroy_row(const struct icnbrec_ic_nb_global *row)
{
    ovsdb_idl_index_destroy_row(&row->header_);
}
        

/* Creates a new row of kind "IC_NB_Global". */
struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_index_init_row(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ic_nb_global);
    return ALIGNED_CAST(struct icnbrec_ic_nb_global *, ovsdb_idl_index_init_row(index));
}

struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_index_find(struct ovsdb_idl_index *index, const struct icnbrec_ic_nb_global *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ic_nb_global);
    return icnbrec_ic_nb_global_cast(ovsdb_idl_index_find(index, &target->header_));
}

/* Compares 'a' to 'b' and returns a strcmp()-type result. */
int
icnbrec_ic_nb_global_index_compare(
    struct ovsdb_idl_index *index, 
    const struct icnbrec_ic_nb_global *a, 
    const struct icnbrec_ic_nb_global *b)
{
    return ovsdb_idl_index_compare(index, &a->header_, &b->header_);
}

struct ovsdb_idl_cursor
icnbrec_ic_nb_global_cursor_first(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ic_nb_global);
    return ovsdb_idl_cursor_first(index);
}

struct ovsdb_idl_cursor
icnbrec_ic_nb_global_cursor_first_eq(
    struct ovsdb_idl_index *index, const struct icnbrec_ic_nb_global *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ic_nb_global);
    return ovsdb_idl_cursor_first_eq(index, &target->header_);
}

struct ovsdb_idl_cursor
icnbrec_ic_nb_global_cursor_first_ge(
    struct ovsdb_idl_index *index, const struct icnbrec_ic_nb_global *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ic_nb_global);
    return ovsdb_idl_cursor_first_ge(index, target ? &target->header_ : NULL);
}

struct icnbrec_ic_nb_global *
icnbrec_ic_nb_global_cursor_data(struct ovsdb_idl_cursor *cursor)
{
    return icnbrec_ic_nb_global_cast(ovsdb_idl_cursor_data(cursor));
}


/* Sets the "connections" column from the "IC_NB_Global" table in 'row' to
 * the 'connections' set with 'n_connections' entries.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_index_set_connections(const struct icnbrec_ic_nb_global *row, struct icnbrec_connection **connections, size_t n_connections)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    size_t i;

    datum.n = n_connections;
    datum.keys = n_connections ? xmalloc(n_connections * sizeof *datum.keys) : NULL;
    datum.values = NULL;
    for (i = 0; i < n_connections; i++) {
        datum.keys[i].uuid = connections[i]->header_.uuid;
    }
    ovsdb_datum_sort_unique(&datum, &icnbrec_ic_nb_global_col_connections.type);
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ic_nb_global_columns[ ICNBREC_IC_NB_GLOBAL_COL_CONNECTIONS ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
}

/* Sets the "external_ids" column's value from the "IC_NB_Global" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_ic_nb_global_index_set_external_ids(const struct icnbrec_ic_nb_global *row, const struct smap *external_ids)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (external_ids) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(external_ids);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, external_ids) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_ic_nb_global_col_external_ids.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_COL_EXTERNAL_IDS],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
    free(datum);
}


/* Sets the "nb_ic_cfg" column from the "IC_NB_Global" table in 'row' to
 * 'nb_ic_cfg'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_index_set_nb_ic_cfg(const struct icnbrec_ic_nb_global *row, int64_t nb_ic_cfg)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->integer = nb_ic_cfg;
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ic_nb_global_columns[ ICNBREC_IC_NB_GLOBAL_COL_NB_IC_CFG ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
}

/* Sets the "options" column's value from the "IC_NB_Global" table in 'row'
 * to 'options'.
 *
 * The caller retains ownership of 'options' and everything in it. */
void
icnbrec_ic_nb_global_index_set_options(const struct icnbrec_ic_nb_global *row, const struct smap *options)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (options) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(options);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, options) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_ic_nb_global_col_options.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_COL_OPTIONS],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
    free(datum);
}


/* Sets the "sb_ic_cfg" column from the "IC_NB_Global" table in 'row' to
 * 'sb_ic_cfg'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_index_set_sb_ic_cfg(const struct icnbrec_ic_nb_global *row, int64_t sb_ic_cfg)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->integer = sb_ic_cfg;
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ic_nb_global_columns[ ICNBREC_IC_NB_GLOBAL_COL_SB_IC_CFG ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
}

/* Sets the "ssl" column from the "IC_NB_Global" table in 'row' to
 * the 'ssl' set.
 *
 * If "ssl" is null, the column will be the empty set,
 * otherwise it will contain the specified value.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ic_nb_global_index_set_ssl(const struct icnbrec_ic_nb_global *row, const struct icnbrec_ssl *ssl)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key;

    if (ssl) {
        key = xmalloc(sizeof (union ovsdb_atom));
        datum.n = 1;
        datum.keys = key;
        key->uuid = ssl->header_.uuid;
    } else {
        datum.n = 0;
        datum.keys = NULL;
    }
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ic_nb_global_columns[ ICNBREC_IC_NB_GLOBAL_COL_SSL ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_IC_NB_GLOBAL]);
}

struct ovsdb_idl_column icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_N_COLUMNS];

unsigned int
icnbrec_ic_nb_global_set_condition(struct ovsdb_idl *idl, struct ovsdb_idl_condition *condition)
{
    return ovsdb_idl_set_condition(idl, &icnbrec_table_ic_nb_global, condition);
}

struct ovsdb_idl_column icnbrec_ic_nb_global_columns[ICNBREC_IC_NB_GLOBAL_N_COLUMNS] = {
    [ICNBREC_IC_NB_GLOBAL_COL_CONNECTIONS] = {
         .name = "connections",
         .type = {
            .key = {
               .type = OVSDB_TYPE_UUID,
               .uuid = { .refTableName = "Connection", .refType = OVSDB_REF_STRONG },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ic_nb_global_parse_connections,
         .unparse = icnbrec_ic_nb_global_unparse_connections,
    },

    [ICNBREC_IC_NB_GLOBAL_COL_EXTERNAL_IDS] = {
         .name = "external_ids",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ic_nb_global_parse_external_ids,
         .unparse = icnbrec_ic_nb_global_unparse_external_ids,
    },

    [ICNBREC_IC_NB_GLOBAL_COL_NB_IC_CFG] = {
         .name = "nb_ic_cfg",
         .type = {
            .key = {
               .type = OVSDB_TYPE_INTEGER,
               .integer = { .min = INT64_MIN, .max = INT64_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ic_nb_global_parse_nb_ic_cfg,
         .unparse = icnbrec_ic_nb_global_unparse_nb_ic_cfg,
    },

    [ICNBREC_IC_NB_GLOBAL_COL_OPTIONS] = {
         .name = "options",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ic_nb_global_parse_options,
         .unparse = icnbrec_ic_nb_global_unparse_options,
    },

    [ICNBREC_IC_NB_GLOBAL_COL_SB_IC_CFG] = {
         .name = "sb_ic_cfg",
         .type = {
            .key = {
               .type = OVSDB_TYPE_INTEGER,
               .integer = { .min = INT64_MIN, .max = INT64_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ic_nb_global_parse_sb_ic_cfg,
         .unparse = icnbrec_ic_nb_global_unparse_sb_ic_cfg,
    },

    [ICNBREC_IC_NB_GLOBAL_COL_SSL] = {
         .name = "ssl",
         .type = {
            .key = {
               .type = OVSDB_TYPE_UUID,
               .uuid = { .refTableName = "SSL", .refType = OVSDB_REF_STRONG },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 0,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ic_nb_global_parse_ssl,
         .unparse = icnbrec_ic_nb_global_unparse_ssl,
    },

};

/* SSL table. */

bool
icnbrec_server_has_ssl_table_col_bootstrap_ca_cert(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_bootstrap_ca_cert);
}


bool
icnbrec_server_has_ssl_table_col_ca_cert(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_ca_cert);
}


bool
icnbrec_server_has_ssl_table_col_certificate(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_certificate);
}


bool
icnbrec_server_has_ssl_table_col_external_ids(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_external_ids);
}


bool
icnbrec_server_has_ssl_table_col_private_key(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_private_key);
}


bool
icnbrec_server_has_ssl_table_col_ssl_ciphers(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_ssl_ciphers);
}


bool
icnbrec_server_has_ssl_table_col_ssl_protocols(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_ssl_col_ssl_protocols);
}


bool
icnbrec_server_has_ssl_table(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_table(idl, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}


const struct icnbrec_ssl_table *
icnbrec_ssl_table_get(const struct ovsdb_idl *idl)
{
    return (const struct icnbrec_ssl_table *) idl;
}

const struct icnbrec_ssl *
icnbrec_ssl_table_first(const struct icnbrec_ssl_table *table)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_ssl_first(idl);
}


const struct icnbrec_ssl *
icnbrec_ssl_table_track_get_first(const struct icnbrec_ssl_table *table)
{
    const struct ovsdb_idl *idl =  (const struct ovsdb_idl *) table;
    return icnbrec_ssl_track_get_first(idl);
}


static void
icnbrec_ssl_parse_bootstrap_ca_cert(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);

    if (datum->n >= 1) {
        row->bootstrap_ca_cert = datum->keys[0].boolean;
    } else {
        row->bootstrap_ca_cert = false;
    }
}

static void
icnbrec_ssl_parse_ca_cert(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);

    if (datum->n >= 1) {
        row->ca_cert = datum->keys[0].s->string;
    } else {
        row->ca_cert = "";
    }
}

static void
icnbrec_ssl_parse_certificate(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);

    if (datum->n >= 1) {
        row->certificate = datum->keys[0].s->string;
    } else {
        row->certificate = "";
    }
}

static void
icnbrec_ssl_parse_external_ids(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);
    smap_init(&row->external_ids);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->external_ids,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_ssl_parse_private_key(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);

    if (datum->n >= 1) {
        row->private_key = datum->keys[0].s->string;
    } else {
        row->private_key = "";
    }
}

static void
icnbrec_ssl_parse_ssl_ciphers(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);

    if (datum->n >= 1) {
        row->ssl_ciphers = datum->keys[0].s->string;
    } else {
        row->ssl_ciphers = "";
    }
}

static void
icnbrec_ssl_parse_ssl_protocols(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);

    if (datum->n >= 1) {
        row->ssl_protocols = datum->keys[0].s->string;
    } else {
        row->ssl_protocols = "";
    }
}

static void
icnbrec_ssl_unparse_bootstrap_ca_cert(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ssl_unparse_ca_cert(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ssl_unparse_certificate(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ssl_unparse_external_ids(struct ovsdb_idl_row *row_)
{
    struct icnbrec_ssl *row = icnbrec_ssl_cast(row_);
    smap_destroy(&row->external_ids);
}

static void
icnbrec_ssl_unparse_private_key(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ssl_unparse_ssl_ciphers(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ssl_unparse_ssl_protocols(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_ssl_init__(struct ovsdb_idl_row *row)
{
    icnbrec_ssl_init(icnbrec_ssl_cast(row));
}

/* Clears the contents of 'row' in table "SSL". */
void
icnbrec_ssl_init(struct icnbrec_ssl *row)
{
    memset(row, 0, sizeof *row); 
    row->ca_cert = "";
    row->certificate = "";
    smap_init(&row->external_ids);
    row->private_key = "";
    row->ssl_ciphers = "";
    row->ssl_protocols = "";
}

/* Searches table "SSL" in 'idl' for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_ssl *
icnbrec_ssl_get_for_uuid(const struct ovsdb_idl *idl, const struct uuid *uuid)
{
    return icnbrec_ssl_cast(ovsdb_idl_get_row_for_uuid(idl, &icnbrec_table_ssl, uuid));
}

/* Searches table "SSL" for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_ssl *
icnbrec_ssl_table_get_for_uuid(const struct icnbrec_ssl_table *table, const struct uuid *uuid)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_ssl_get_for_uuid(idl, uuid);
}

/* Returns a row in table "SSL" in 'idl', or a null pointer if that
 * table is empty.
 *
 * Database tables are internally maintained as hash tables, so adding or
 * removing rows while traversing the same table can cause some rows to be
 * visited twice or not at apply. */
const struct icnbrec_ssl *
icnbrec_ssl_first(const struct ovsdb_idl *idl)
{
    return icnbrec_ssl_cast(ovsdb_idl_first_row(idl, &icnbrec_table_ssl));
}

/* Returns a row following 'row' within its table, or a null pointer if 'row'
 * is the last row in its table. */
const struct icnbrec_ssl *
icnbrec_ssl_next(const struct icnbrec_ssl *row)
{
    return icnbrec_ssl_cast(ovsdb_idl_next_row(&row->header_));
}

unsigned int icnbrec_ssl_get_seqno(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_table_get_seqno(idl, &icnbrec_table_ssl);
}

unsigned int icnbrec_ssl_row_get_seqno(const struct icnbrec_ssl *row, enum ovsdb_idl_change change)
{
    return ovsdb_idl_row_get_seqno(&row->header_, change);
}

const struct icnbrec_ssl *
icnbrec_ssl_track_get_first(const struct ovsdb_idl *idl)
{
    return icnbrec_ssl_cast(ovsdb_idl_track_get_first(idl, &icnbrec_table_ssl));
}

const struct icnbrec_ssl
*icnbrec_ssl_track_get_next(const struct icnbrec_ssl *row)
{
    return icnbrec_ssl_cast(ovsdb_idl_track_get_next(&row->header_));
}


/* Deletes 'row' from table "SSL".  'row' may be freed, so it must not be
 * accessed afterward.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_delete(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_delete(&row->header_);
}

/* Inserts and returns a new row in the table "SSL" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned a randomly generated provisional UUID.
 * ovsdb-server will assign a different UUID when 'txn' is committed,
 * but the IDL will replace any uses of the provisional UUID in the
 * data to be to be committed by the UUID assigned by ovsdb-server. */
struct icnbrec_ssl *
icnbrec_ssl_insert(struct ovsdb_idl_txn *txn)
{
    return icnbrec_ssl_cast(ovsdb_idl_txn_insert(txn, &icnbrec_table_ssl, NULL));
}

/* Inserts and returns a new row in the table "SSL" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned the UUID specified in the 'uuid' parameter
 * (which cannot be null).  ovsdb-server will try to assign the same
 * UUID when 'txn' is committed. */
struct icnbrec_ssl *
icnbrec_ssl_insert_persist_uuid(struct ovsdb_idl_txn *txn, const struct uuid *uuid)
{
    return icnbrec_ssl_cast(ovsdb_idl_txn_insert_persist_uuid(
        txn, &icnbrec_table_ssl, uuid));
}

bool
icnbrec_ssl_is_updated(const struct icnbrec_ssl *row, enum icnbrec_ssl_column_id column)
{
    return ovsdb_idl_track_is_updated(&row->header_, &icnbrec_ssl_columns[column]);
}

/* Causes the original contents of column "bootstrap_ca_cert" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "bootstrap_ca_cert" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "bootstrap_ca_cert" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "bootstrap_ca_cert" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "bootstrap_ca_cert" has already been modified (with
 *     icnbrec_ssl_set_bootstrap_ca_cert()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_bootstrap_ca_cert() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_bootstrap_ca_cert(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_bootstrap_ca_cert);
}

/* Causes the original contents of column "ca_cert" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "ca_cert" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "ca_cert" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "ca_cert" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "ca_cert" has already been modified (with
 *     icnbrec_ssl_set_ca_cert()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_ca_cert() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_ca_cert(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_ca_cert);
}

/* Causes the original contents of column "certificate" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "certificate" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "certificate" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "certificate" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "certificate" has already been modified (with
 *     icnbrec_ssl_set_certificate()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_certificate() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_certificate(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_certificate);
}

/* Causes the original contents of column "external_ids" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "external_ids" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "external_ids" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "external_ids" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "external_ids" has already been modified (with
 *     icnbrec_ssl_set_external_ids()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_external_ids() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_external_ids(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_external_ids);
}

/* Causes the original contents of column "private_key" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "private_key" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "private_key" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "private_key" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "private_key" has already been modified (with
 *     icnbrec_ssl_set_private_key()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_private_key() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_private_key(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_private_key);
}

/* Causes the original contents of column "ssl_ciphers" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "ssl_ciphers" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "ssl_ciphers" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "ssl_ciphers" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "ssl_ciphers" has already been modified (with
 *     icnbrec_ssl_set_ssl_ciphers()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_ssl_ciphers() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_ssl_ciphers(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_ssl_ciphers);
}

/* Causes the original contents of column "ssl_protocols" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "ssl_protocols" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "ssl_protocols" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "ssl_protocols" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_ssl_insert()).
 *
 *   - If "ssl_protocols" has already been modified (with
 *     icnbrec_ssl_set_ssl_protocols()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_ssl_set_ssl_protocols() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_ssl_verify_ssl_protocols(const struct icnbrec_ssl *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_ssl_col_ssl_protocols);
}

/* Returns the "bootstrap_ca_cert" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_BOOLEAN.
 * (This helps to avoid silent bugs if someone changes bootstrap_ca_cert's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "bootstrap_ca_cert" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_bootstrap_ca_cert(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_BOOLEAN);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_bootstrap_ca_cert);
}

/* Returns the "ca_cert" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes ca_cert's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "ca_cert" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_ca_cert(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_ca_cert);
}

/* Returns the "certificate" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes certificate's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "certificate" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_certificate(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_certificate);
}

/* Returns the "external_ids" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes external_ids's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "external_ids" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_external_ids(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_external_ids);
}

/* Returns the "private_key" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes private_key's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "private_key" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_private_key(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_private_key);
}

/* Returns the "ssl_ciphers" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes ssl_ciphers's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "ssl_ciphers" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_ssl_ciphers(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_ssl_ciphers);
}

/* Returns the "ssl_protocols" column's value from the "SSL" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes ssl_protocols's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "ssl_protocols" member in icnbrec_ssl. */
const struct ovsdb_datum *
icnbrec_ssl_get_ssl_protocols(const struct icnbrec_ssl *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_ssl_col_ssl_protocols);
}

/* Sets the "bootstrap_ca_cert" column from the "SSL" table in 'row' to
 * 'bootstrap_ca_cert'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_set_bootstrap_ca_cert(const struct icnbrec_ssl *row, bool bootstrap_ca_cert)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->boolean = bootstrap_ca_cert;
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ssl_col_bootstrap_ca_cert, &datum);
}

/* Sets the "ca_cert" column from the "SSL" table in 'row' to
 * 'ca_cert'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_set_ca_cert(const struct icnbrec_ssl *row, const char *ca_cert)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ca_cert);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ssl_col_ca_cert, &datum);
}

/* Sets the "certificate" column from the "SSL" table in 'row' to
 * 'certificate'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_set_certificate(const struct icnbrec_ssl *row, const char *certificate)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(certificate);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ssl_col_certificate, &datum);
}

/* Sets the "external_ids" column's value from the "SSL" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_ssl_set_external_ids(const struct icnbrec_ssl *row, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_ssl_col_external_ids,
                        &datum);
}


/* Sets the "private_key" column from the "SSL" table in 'row' to
 * 'private_key'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_set_private_key(const struct icnbrec_ssl *row, const char *private_key)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(private_key);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ssl_col_private_key, &datum);
}

/* Sets the "ssl_ciphers" column from the "SSL" table in 'row' to
 * 'ssl_ciphers'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_set_ssl_ciphers(const struct icnbrec_ssl *row, const char *ssl_ciphers)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ssl_ciphers);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ssl_col_ssl_ciphers, &datum);
}

/* Sets the "ssl_protocols" column from the "SSL" table in 'row' to
 * 'ssl_protocols'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_set_ssl_protocols(const struct icnbrec_ssl *row, const char *ssl_protocols)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ssl_protocols);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_ssl_col_ssl_protocols, &datum);
}

/* Sets an element of the "external_ids" map column from the "SSL" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_ssl_update_external_ids_setkey(const struct icnbrec_ssl *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_ssl_col_external_ids,
                                    datum);
}

/* Deletes an element of the "external_ids" map column from the "SSL" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_ssl_update_external_ids_delkey(const struct icnbrec_ssl *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_ssl_col_external_ids,
                                    datum);
}

/* Sets the "bootstrap_ca_cert" column from the "SSL" table in 'row' to
 * 'bootstrap_ca_cert'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_add_clause_bootstrap_ca_cert(struct ovsdb_idl_condition *cond, enum ovsdb_function function, bool bootstrap_ca_cert)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->boolean = bootstrap_ca_cert;
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ssl_col_bootstrap_ca_cert,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_bootstrap_ca_cert.type);
}

/* Sets the "ca_cert" column from the "SSL" table in 'row' to
 * 'ca_cert'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_add_clause_ca_cert(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *ca_cert)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ca_cert);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ssl_col_ca_cert,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_ca_cert.type);
}

/* Sets the "certificate" column from the "SSL" table in 'row' to
 * 'certificate'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_add_clause_certificate(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *certificate)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(certificate);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ssl_col_certificate,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_certificate.type);
}

/* Sets the "external_ids" column's value from the "SSL" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_ssl_add_clause_external_ids(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_ssl_col_external_ids,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_external_ids.type);
}


/* Sets the "private_key" column from the "SSL" table in 'row' to
 * 'private_key'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_add_clause_private_key(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *private_key)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(private_key);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ssl_col_private_key,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_private_key.type);
}

/* Sets the "ssl_ciphers" column from the "SSL" table in 'row' to
 * 'ssl_ciphers'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_add_clause_ssl_ciphers(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *ssl_ciphers)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ssl_ciphers);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ssl_col_ssl_ciphers,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_ssl_ciphers.type);
}

/* Sets the "ssl_protocols" column from the "SSL" table in 'row' to
 * 'ssl_protocols'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_add_clause_ssl_protocols(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *ssl_protocols)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ssl_protocols);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_ssl_col_ssl_protocols,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_ssl_col_ssl_protocols.type);
}

/* Destroy 'row' of kind "SSL". The row must have been
 * created with ovsdb_idl_index_init_row.
 */
void
icnbrec_ssl_index_destroy_row(const struct icnbrec_ssl *row)
{
    ovsdb_idl_index_destroy_row(&row->header_);
}
        

/* Creates a new row of kind "SSL". */
struct icnbrec_ssl *
icnbrec_ssl_index_init_row(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ssl);
    return ALIGNED_CAST(struct icnbrec_ssl *, ovsdb_idl_index_init_row(index));
}

struct icnbrec_ssl *
icnbrec_ssl_index_find(struct ovsdb_idl_index *index, const struct icnbrec_ssl *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ssl);
    return icnbrec_ssl_cast(ovsdb_idl_index_find(index, &target->header_));
}

/* Compares 'a' to 'b' and returns a strcmp()-type result. */
int
icnbrec_ssl_index_compare(
    struct ovsdb_idl_index *index, 
    const struct icnbrec_ssl *a, 
    const struct icnbrec_ssl *b)
{
    return ovsdb_idl_index_compare(index, &a->header_, &b->header_);
}

struct ovsdb_idl_cursor
icnbrec_ssl_cursor_first(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ssl);
    return ovsdb_idl_cursor_first(index);
}

struct ovsdb_idl_cursor
icnbrec_ssl_cursor_first_eq(
    struct ovsdb_idl_index *index, const struct icnbrec_ssl *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ssl);
    return ovsdb_idl_cursor_first_eq(index, &target->header_);
}

struct ovsdb_idl_cursor
icnbrec_ssl_cursor_first_ge(
    struct ovsdb_idl_index *index, const struct icnbrec_ssl *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_ssl);
    return ovsdb_idl_cursor_first_ge(index, target ? &target->header_ : NULL);
}

struct icnbrec_ssl *
icnbrec_ssl_cursor_data(struct ovsdb_idl_cursor *cursor)
{
    return icnbrec_ssl_cast(ovsdb_idl_cursor_data(cursor));
}


/* Sets the "bootstrap_ca_cert" column from the "SSL" table in 'row' to
 * 'bootstrap_ca_cert'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_index_set_bootstrap_ca_cert(const struct icnbrec_ssl *row, bool bootstrap_ca_cert)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->boolean = bootstrap_ca_cert;
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ssl_columns[ ICNBREC_SSL_COL_BOOTSTRAP_CA_CERT ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}

/* Sets the "ca_cert" column from the "SSL" table in 'row' to
 * 'ca_cert'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_index_set_ca_cert(const struct icnbrec_ssl *row, const char *ca_cert)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ca_cert);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ssl_columns[ ICNBREC_SSL_COL_CA_CERT ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}

/* Sets the "certificate" column from the "SSL" table in 'row' to
 * 'certificate'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_index_set_certificate(const struct icnbrec_ssl *row, const char *certificate)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(certificate);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ssl_columns[ ICNBREC_SSL_COL_CERTIFICATE ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}

/* Sets the "external_ids" column's value from the "SSL" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_ssl_index_set_external_ids(const struct icnbrec_ssl *row, const struct smap *external_ids)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (external_ids) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(external_ids);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, external_ids) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_ssl_col_external_ids.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_ssl_columns[ICNBREC_SSL_COL_EXTERNAL_IDS],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
    free(datum);
}


/* Sets the "private_key" column from the "SSL" table in 'row' to
 * 'private_key'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_index_set_private_key(const struct icnbrec_ssl *row, const char *private_key)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(private_key);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ssl_columns[ ICNBREC_SSL_COL_PRIVATE_KEY ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}

/* Sets the "ssl_ciphers" column from the "SSL" table in 'row' to
 * 'ssl_ciphers'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_index_set_ssl_ciphers(const struct icnbrec_ssl *row, const char *ssl_ciphers)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ssl_ciphers);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ssl_columns[ ICNBREC_SSL_COL_SSL_CIPHERS ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}

/* Sets the "ssl_protocols" column from the "SSL" table in 'row' to
 * 'ssl_protocols'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_ssl_index_set_ssl_protocols(const struct icnbrec_ssl *row, const char *ssl_protocols)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(ssl_protocols);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_ssl_columns[ ICNBREC_SSL_COL_SSL_PROTOCOLS ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_SSL]);
}

struct ovsdb_idl_column icnbrec_ssl_columns[ICNBREC_SSL_N_COLUMNS];

unsigned int
icnbrec_ssl_set_condition(struct ovsdb_idl *idl, struct ovsdb_idl_condition *condition)
{
    return ovsdb_idl_set_condition(idl, &icnbrec_table_ssl, condition);
}

struct ovsdb_idl_column icnbrec_ssl_columns[ICNBREC_SSL_N_COLUMNS] = {
    [ICNBREC_SSL_COL_BOOTSTRAP_CA_CERT] = {
         .name = "bootstrap_ca_cert",
         .type = {
            .key = {
               .type = OVSDB_TYPE_BOOLEAN,
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_bootstrap_ca_cert,
         .unparse = icnbrec_ssl_unparse_bootstrap_ca_cert,
    },

    [ICNBREC_SSL_COL_CA_CERT] = {
         .name = "ca_cert",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_ca_cert,
         .unparse = icnbrec_ssl_unparse_ca_cert,
    },

    [ICNBREC_SSL_COL_CERTIFICATE] = {
         .name = "certificate",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_certificate,
         .unparse = icnbrec_ssl_unparse_certificate,
    },

    [ICNBREC_SSL_COL_EXTERNAL_IDS] = {
         .name = "external_ids",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_external_ids,
         .unparse = icnbrec_ssl_unparse_external_ids,
    },

    [ICNBREC_SSL_COL_PRIVATE_KEY] = {
         .name = "private_key",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_private_key,
         .unparse = icnbrec_ssl_unparse_private_key,
    },

    [ICNBREC_SSL_COL_SSL_CIPHERS] = {
         .name = "ssl_ciphers",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_ssl_ciphers,
         .unparse = icnbrec_ssl_unparse_ssl_ciphers,
    },

    [ICNBREC_SSL_COL_SSL_PROTOCOLS] = {
         .name = "ssl_protocols",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_ssl_parse_ssl_protocols,
         .unparse = icnbrec_ssl_unparse_ssl_protocols,
    },

};

/* Transit_Switch table. */

bool
icnbrec_server_has_transit_switch_table_col_external_ids(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_transit_switch_col_external_ids);
}


bool
icnbrec_server_has_transit_switch_table_col_name(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_transit_switch_col_name);
}


bool
icnbrec_server_has_transit_switch_table_col_other_config(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_column(idl, &icnbrec_transit_switch_col_other_config);
}


bool
icnbrec_server_has_transit_switch_table(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_server_has_table(idl, &icnbrec_table_classes[ICNBREC_TABLE_TRANSIT_SWITCH]);
}


const struct icnbrec_transit_switch_table *
icnbrec_transit_switch_table_get(const struct ovsdb_idl *idl)
{
    return (const struct icnbrec_transit_switch_table *) idl;
}

const struct icnbrec_transit_switch *
icnbrec_transit_switch_table_first(const struct icnbrec_transit_switch_table *table)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_transit_switch_first(idl);
}


const struct icnbrec_transit_switch *
icnbrec_transit_switch_table_track_get_first(const struct icnbrec_transit_switch_table *table)
{
    const struct ovsdb_idl *idl =  (const struct ovsdb_idl *) table;
    return icnbrec_transit_switch_track_get_first(idl);
}


static void
icnbrec_transit_switch_parse_external_ids(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_transit_switch *row = icnbrec_transit_switch_cast(row_);
    smap_init(&row->external_ids);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->external_ids,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_transit_switch_parse_name(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_transit_switch *row = icnbrec_transit_switch_cast(row_);

    if (datum->n >= 1) {
        row->name = datum->keys[0].s->string;
    } else {
        row->name = "";
    }
}

static void
icnbrec_transit_switch_parse_other_config(struct ovsdb_idl_row *row_, const struct ovsdb_datum *datum)
{
    struct icnbrec_transit_switch *row = icnbrec_transit_switch_cast(row_);
    smap_init(&row->other_config);
    for (size_t i = 0; i < datum->n; i++) {
        smap_add(&row->other_config,
                 json_string(datum->keys[i].s),
                 json_string(datum->values[i].s));
    }
}

static void
icnbrec_transit_switch_unparse_external_ids(struct ovsdb_idl_row *row_)
{
    struct icnbrec_transit_switch *row = icnbrec_transit_switch_cast(row_);
    smap_destroy(&row->external_ids);
}

static void
icnbrec_transit_switch_unparse_name(struct ovsdb_idl_row *row OVS_UNUSED)
{
    /* Nothing to do. */
}

static void
icnbrec_transit_switch_unparse_other_config(struct ovsdb_idl_row *row_)
{
    struct icnbrec_transit_switch *row = icnbrec_transit_switch_cast(row_);
    smap_destroy(&row->other_config);
}

static void
icnbrec_transit_switch_init__(struct ovsdb_idl_row *row)
{
    icnbrec_transit_switch_init(icnbrec_transit_switch_cast(row));
}

/* Clears the contents of 'row' in table "Transit_Switch". */
void
icnbrec_transit_switch_init(struct icnbrec_transit_switch *row)
{
    memset(row, 0, sizeof *row); 
    smap_init(&row->external_ids);
    row->name = "";
    smap_init(&row->other_config);
}

/* Searches table "Transit_Switch" in 'idl' for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_transit_switch *
icnbrec_transit_switch_get_for_uuid(const struct ovsdb_idl *idl, const struct uuid *uuid)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_get_row_for_uuid(idl, &icnbrec_table_transit_switch, uuid));
}

/* Searches table "Transit_Switch" for a row with UUID 'uuid'.  Returns
 * a pointer to the row if there is one, otherwise a null pointer.  */
const struct icnbrec_transit_switch *
icnbrec_transit_switch_table_get_for_uuid(const struct icnbrec_transit_switch_table *table, const struct uuid *uuid)
{
    const struct ovsdb_idl *idl = (const struct ovsdb_idl *) table;
    return icnbrec_transit_switch_get_for_uuid(idl, uuid);
}

/* Returns a row in table "Transit_Switch" in 'idl', or a null pointer if that
 * table is empty.
 *
 * Database tables are internally maintained as hash tables, so adding or
 * removing rows while traversing the same table can cause some rows to be
 * visited twice or not at apply. */
const struct icnbrec_transit_switch *
icnbrec_transit_switch_first(const struct ovsdb_idl *idl)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_first_row(idl, &icnbrec_table_transit_switch));
}

/* Returns a row following 'row' within its table, or a null pointer if 'row'
 * is the last row in its table. */
const struct icnbrec_transit_switch *
icnbrec_transit_switch_next(const struct icnbrec_transit_switch *row)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_next_row(&row->header_));
}

unsigned int icnbrec_transit_switch_get_seqno(const struct ovsdb_idl *idl)
{
    return ovsdb_idl_table_get_seqno(idl, &icnbrec_table_transit_switch);
}

unsigned int icnbrec_transit_switch_row_get_seqno(const struct icnbrec_transit_switch *row, enum ovsdb_idl_change change)
{
    return ovsdb_idl_row_get_seqno(&row->header_, change);
}

const struct icnbrec_transit_switch *
icnbrec_transit_switch_track_get_first(const struct ovsdb_idl *idl)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_track_get_first(idl, &icnbrec_table_transit_switch));
}

const struct icnbrec_transit_switch
*icnbrec_transit_switch_track_get_next(const struct icnbrec_transit_switch *row)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_track_get_next(&row->header_));
}


/* Deletes 'row' from table "Transit_Switch".  'row' may be freed, so it must not be
 * accessed afterward.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_transit_switch_delete(const struct icnbrec_transit_switch *row)
{
    ovsdb_idl_txn_delete(&row->header_);
}

/* Inserts and returns a new row in the table "Transit_Switch" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned a randomly generated provisional UUID.
 * ovsdb-server will assign a different UUID when 'txn' is committed,
 * but the IDL will replace any uses of the provisional UUID in the
 * data to be to be committed by the UUID assigned by ovsdb-server. */
struct icnbrec_transit_switch *
icnbrec_transit_switch_insert(struct ovsdb_idl_txn *txn)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_txn_insert(txn, &icnbrec_table_transit_switch, NULL));
}

/* Inserts and returns a new row in the table "Transit_Switch" in the database
 * with open transaction 'txn'.
 *
 * The new row is assigned the UUID specified in the 'uuid' parameter
 * (which cannot be null).  ovsdb-server will try to assign the same
 * UUID when 'txn' is committed. */
struct icnbrec_transit_switch *
icnbrec_transit_switch_insert_persist_uuid(struct ovsdb_idl_txn *txn, const struct uuid *uuid)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_txn_insert_persist_uuid(
        txn, &icnbrec_table_transit_switch, uuid));
}

bool
icnbrec_transit_switch_is_updated(const struct icnbrec_transit_switch *row, enum icnbrec_transit_switch_column_id column)
{
    return ovsdb_idl_track_is_updated(&row->header_, &icnbrec_transit_switch_columns[column]);
}

/* Causes the original contents of column "external_ids" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "external_ids" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "external_ids" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "external_ids" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_transit_switch_insert()).
 *
 *   - If "external_ids" has already been modified (with
 *     icnbrec_transit_switch_set_external_ids()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_transit_switch_set_external_ids() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_transit_switch_verify_external_ids(const struct icnbrec_transit_switch *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_transit_switch_col_external_ids);
}

/* Causes the original contents of column "name" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "name" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "name" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "name" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_transit_switch_insert()).
 *
 *   - If "name" has already been modified (with
 *     icnbrec_transit_switch_set_name()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_transit_switch_set_name() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_transit_switch_verify_name(const struct icnbrec_transit_switch *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_transit_switch_col_name);
}

/* Causes the original contents of column "other_config" in 'row' to be
 * verified as a prerequisite to completing the transaction.  That is, if
 * "other_config" in 'row' changed (or if 'row' was deleted) between the
 * time that the IDL originally read its contents and the time that the
 * transaction aborts and ovsdb_idl_txn_commit() returns TXN_TRY_AGAIN.
 *
 * The intention is that, to ensure that no transaction commits based on dirty
 * reads, an application should call this function any time "other_config" is
 * read as part of a read-modify-write operation.
 *
 * In some cases this function reduces to a no-op, because the current value
 * of "other_config" is already known:
 *
 *   - If 'row' is a row created by the current transaction (returned by
 *     icnbrec_transit_switch_insert()).
 *
 *   - If "other_config" has already been modified (with
 *     icnbrec_transit_switch_set_other_config()) within the current transaction.
 *
 * Because of the latter property, always call this function *before*
 * icnbrec_transit_switch_set_other_config() for a given read-modify-write.
 *
 * The caller must have started a transaction with ovsdb_idl_txn_create(). */
void
icnbrec_transit_switch_verify_other_config(const struct icnbrec_transit_switch *row)
{
    ovsdb_idl_txn_verify(&row->header_, &icnbrec_transit_switch_col_other_config);
}

/* Returns the "external_ids" column's value from the "Transit_Switch" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes external_ids's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "external_ids" member in icnbrec_transit_switch. */
const struct ovsdb_datum *
icnbrec_transit_switch_get_external_ids(const struct icnbrec_transit_switch *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_transit_switch_col_external_ids);
}

/* Returns the "name" column's value from the "Transit_Switch" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes name's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "name" member in icnbrec_transit_switch. */
const struct ovsdb_datum *
icnbrec_transit_switch_get_name(const struct icnbrec_transit_switch *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_transit_switch_col_name);
}

/* Returns the "other_config" column's value from the "Transit_Switch" table in 'row'
 * as a struct ovsdb_datum.  This is useful occasionally: for example,
 * ovsdb_datum_find_key() is an easier and more efficient way to search
 * for a given key than implementing the same operation on the "cooked"
 * form in 'row'.
 *
 * 'key_type' must be OVSDB_TYPE_STRING.
 * 'value_type' must be OVSDB_TYPE_STRING.
 * (This helps to avoid silent bugs if someone changes other_config's
 * type without updating the caller.)
 *
 * The caller must not modify or free the returned value.
 *
 * Various kinds of changes can invalidate the returned value: modifying
 * 'column' within 'row', deleting 'row', or completing an ongoing transaction.
 * If the returned value is needed for a long time, it is best to make a copy
 * of it with ovsdb_datum_clone().
 *
 * This function is rarely useful, since it is easier to access the value
 * directly through the "other_config" member in icnbrec_transit_switch. */
const struct ovsdb_datum *
icnbrec_transit_switch_get_other_config(const struct icnbrec_transit_switch *row,
	enum ovsdb_atomic_type key_type OVS_UNUSED,
	enum ovsdb_atomic_type value_type OVS_UNUSED)
{
    ovs_assert(key_type == OVSDB_TYPE_STRING);
    ovs_assert(value_type == OVSDB_TYPE_STRING);
    return ovsdb_idl_read(&row->header_, &icnbrec_transit_switch_col_other_config);
}

/* Sets the "external_ids" column's value from the "Transit_Switch" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_transit_switch_set_external_ids(const struct icnbrec_transit_switch *row, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_transit_switch_col_external_ids,
                        &datum);
}


/* Sets the "name" column from the "Transit_Switch" table in 'row' to
 * 'name'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_transit_switch_set_name(const struct icnbrec_transit_switch *row, const char *name)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(name);
    datum.values = NULL;
    ovsdb_idl_txn_write(&row->header_, &icnbrec_transit_switch_col_name, &datum);
}

/* Sets the "other_config" column's value from the "Transit_Switch" table in 'row'
 * to 'other_config'.
 *
 * The caller retains ownership of 'other_config' and everything in it. */
void
icnbrec_transit_switch_set_other_config(const struct icnbrec_transit_switch *row, const struct smap *other_config)
{
    struct ovsdb_datum datum;

    if (other_config) {
        ovsdb_datum_from_smap(&datum, other_config);
    } else {
        ovsdb_datum_init_empty(&datum);
    }
    ovsdb_idl_txn_write(&row->header_,
                        &icnbrec_transit_switch_col_other_config,
                        &datum);
}


/* Sets an element of the "external_ids" map column from the "Transit_Switch" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_transit_switch_update_external_ids_setkey(const struct icnbrec_transit_switch *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_transit_switch_col_external_ids,
                                    datum);
}

/* Deletes an element of the "external_ids" map column from the "Transit_Switch" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_transit_switch_update_external_ids_delkey(const struct icnbrec_transit_switch *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_transit_switch_col_external_ids,
                                    datum);
}

/* Sets an element of the "other_config" map column from the "Transit_Switch" table in 'row'
 * to 'new_value' given the key value 'new_key'.
 *
 */
void
icnbrec_transit_switch_update_other_config_setkey(const struct icnbrec_transit_switch *row, const char *new_key, const char *new_value)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = xmalloc(datum->n * sizeof *datum->values);
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(new_key);
    datum->values[0].s = ovsdb_atom_string_create(new_value);

    ovsdb_idl_txn_write_partial_map(&row->header_,
                                    &icnbrec_transit_switch_col_other_config,
                                    datum);
}

/* Deletes an element of the "other_config" map column from the "Transit_Switch" table in 'row'
 * given the key value 'delete_key'.
 *
 */
void
icnbrec_transit_switch_update_other_config_delkey(const struct icnbrec_transit_switch *row, const char *delete_key)
{
    struct ovsdb_datum *datum;

    datum = xmalloc(sizeof *datum);
    datum->n = 1;
    datum->keys = xmalloc(datum->n * sizeof *datum->keys);
    datum->values = NULL;
    datum->refcnt = NULL;

    datum->keys[0].s = ovsdb_atom_string_create(delete_key);

    ovsdb_idl_txn_delete_partial_map(&row->header_,
                                    &icnbrec_transit_switch_col_other_config,
                                    datum);
}

/* Sets the "external_ids" column's value from the "Transit_Switch" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_transit_switch_add_clause_external_ids(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *external_ids)
{
    struct ovsdb_datum datum;

    if (external_ids) {
        ovsdb_datum_from_smap(&datum, external_ids);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_transit_switch_col_external_ids,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_transit_switch_col_external_ids.type);
}


/* Sets the "name" column from the "Transit_Switch" table in 'row' to
 * 'name'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_transit_switch_add_clause_name(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const char *name)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;

    union ovsdb_atom *key = xmalloc(sizeof *key);

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(name);
    datum.values = NULL;
    ovsdb_idl_condition_add_clause(cond,
                          function,
                          &icnbrec_transit_switch_col_name,
                          &datum);
    ovsdb_datum_destroy(&datum, &icnbrec_transit_switch_col_name.type);
}

/* Sets the "other_config" column's value from the "Transit_Switch" table in 'row'
 * to 'other_config'.
 *
 * The caller retains ownership of 'other_config' and everything in it. */
void
icnbrec_transit_switch_add_clause_other_config(struct ovsdb_idl_condition *cond, enum ovsdb_function function, const struct smap *other_config)
{
    struct ovsdb_datum datum;

    if (other_config) {
        ovsdb_datum_from_smap(&datum, other_config);
    } else {
        ovsdb_datum_init_empty(&datum);
    }

    ovsdb_idl_condition_add_clause(cond,
                                   function,
                                   &icnbrec_transit_switch_col_other_config,
                                   &datum);

    ovsdb_datum_destroy(&datum, &icnbrec_transit_switch_col_other_config.type);
}


/* Destroy 'row' of kind "Transit_Switch". The row must have been
 * created with ovsdb_idl_index_init_row.
 */
void
icnbrec_transit_switch_index_destroy_row(const struct icnbrec_transit_switch *row)
{
    ovsdb_idl_index_destroy_row(&row->header_);
}
        

/* Creates a new row of kind "Transit_Switch". */
struct icnbrec_transit_switch *
icnbrec_transit_switch_index_init_row(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_transit_switch);
    return ALIGNED_CAST(struct icnbrec_transit_switch *, ovsdb_idl_index_init_row(index));
}

struct icnbrec_transit_switch *
icnbrec_transit_switch_index_find(struct ovsdb_idl_index *index, const struct icnbrec_transit_switch *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_transit_switch);
    return icnbrec_transit_switch_cast(ovsdb_idl_index_find(index, &target->header_));
}

/* Compares 'a' to 'b' and returns a strcmp()-type result. */
int
icnbrec_transit_switch_index_compare(
    struct ovsdb_idl_index *index, 
    const struct icnbrec_transit_switch *a, 
    const struct icnbrec_transit_switch *b)
{
    return ovsdb_idl_index_compare(index, &a->header_, &b->header_);
}

struct ovsdb_idl_cursor
icnbrec_transit_switch_cursor_first(struct ovsdb_idl_index *index)
{
    ovs_assert(index->table->class_ == &icnbrec_table_transit_switch);
    return ovsdb_idl_cursor_first(index);
}

struct ovsdb_idl_cursor
icnbrec_transit_switch_cursor_first_eq(
    struct ovsdb_idl_index *index, const struct icnbrec_transit_switch *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_transit_switch);
    return ovsdb_idl_cursor_first_eq(index, &target->header_);
}

struct ovsdb_idl_cursor
icnbrec_transit_switch_cursor_first_ge(
    struct ovsdb_idl_index *index, const struct icnbrec_transit_switch *target)
{
    ovs_assert(index->table->class_ == &icnbrec_table_transit_switch);
    return ovsdb_idl_cursor_first_ge(index, target ? &target->header_ : NULL);
}

struct icnbrec_transit_switch *
icnbrec_transit_switch_cursor_data(struct ovsdb_idl_cursor *cursor)
{
    return icnbrec_transit_switch_cast(ovsdb_idl_cursor_data(cursor));
}


/* Sets the "external_ids" column's value from the "Transit_Switch" table in 'row'
 * to 'external_ids'.
 *
 * The caller retains ownership of 'external_ids' and everything in it. */
void
icnbrec_transit_switch_index_set_external_ids(const struct icnbrec_transit_switch *row, const struct smap *external_ids)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (external_ids) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(external_ids);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, external_ids) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_transit_switch_col_external_ids.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_COL_EXTERNAL_IDS],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_TRANSIT_SWITCH]);
    free(datum);
}


/* Sets the "name" column from the "Transit_Switch" table in 'row' to
 * 'name'.
 *
 * The caller retains ownership of the arguments. */
void
icnbrec_transit_switch_index_set_name(const struct icnbrec_transit_switch *row, const char *name)
{
    struct ovsdb_datum datum;

    datum.refcnt = NULL;
    union ovsdb_atom *key = xmalloc(sizeof(union ovsdb_atom));

    datum.n = 1;
    datum.keys = key;
    key->s = ovsdb_atom_string_create(name);
    datum.values = NULL;
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_), &icnbrec_transit_switch_columns[ ICNBREC_TRANSIT_SWITCH_COL_NAME ], &datum, &icnbrec_table_classes[ICNBREC_TABLE_TRANSIT_SWITCH]);
}

/* Sets the "other_config" column's value from the "Transit_Switch" table in 'row'
 * to 'other_config'.
 *
 * The caller retains ownership of 'other_config' and everything in it. */
void
icnbrec_transit_switch_index_set_other_config(const struct icnbrec_transit_switch *row, const struct smap *other_config)
{
    struct ovsdb_datum *datum = xmalloc(sizeof(struct ovsdb_datum));

    if (other_config) {
        struct smap_node *node;
        size_t i;

        datum->n = smap_count(other_config);
        datum->keys = xmalloc(datum->n * sizeof *datum->keys);
        datum->values = xmalloc(datum->n * sizeof *datum->values);
        datum->refcnt = NULL;

        i = 0;
        SMAP_FOR_EACH (node, other_config) {
            datum->keys[i].s = ovsdb_atom_string_create(node->key);
            datum->values[i].s = ovsdb_atom_string_create(node->value);
            i++;
        }
        ovsdb_datum_sort_unique(datum, &icnbrec_transit_switch_col_other_config.type);
    } else {
        ovsdb_datum_init_empty(datum);
    }
    ovsdb_idl_index_write(CONST_CAST(struct ovsdb_idl_row *, &row->header_),
                          &icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_COL_OTHER_CONFIG],
                          datum,
                          &icnbrec_table_classes[ICNBREC_TABLE_TRANSIT_SWITCH]);
    free(datum);
}


struct ovsdb_idl_column icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_N_COLUMNS];

unsigned int
icnbrec_transit_switch_set_condition(struct ovsdb_idl *idl, struct ovsdb_idl_condition *condition)
{
    return ovsdb_idl_set_condition(idl, &icnbrec_table_transit_switch, condition);
}

struct ovsdb_idl_column icnbrec_transit_switch_columns[ICNBREC_TRANSIT_SWITCH_N_COLUMNS] = {
    [ICNBREC_TRANSIT_SWITCH_COL_EXTERNAL_IDS] = {
         .name = "external_ids",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_transit_switch_parse_external_ids,
         .unparse = icnbrec_transit_switch_unparse_external_ids,
    },

    [ICNBREC_TRANSIT_SWITCH_COL_NAME] = {
         .name = "name",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = OVSDB_BASE_VOID_INIT,
            .n_min = 1,
            .n_max = 1,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_transit_switch_parse_name,
         .unparse = icnbrec_transit_switch_unparse_name,
    },

    [ICNBREC_TRANSIT_SWITCH_COL_OTHER_CONFIG] = {
         .name = "other_config",
         .type = {
            .key = {
               .type = OVSDB_TYPE_STRING,
               .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .value = {
                .type = OVSDB_TYPE_STRING,
                .string = { .minLen = 0, .maxLen = UINT_MAX },
            },
            .n_min = 0,
            .n_max = UINT_MAX,
         },
         .is_mutable = true,
         .is_synthetic = false,
         .parse = icnbrec_transit_switch_parse_other_config,
         .unparse = icnbrec_transit_switch_unparse_other_config,
    },

};

struct ovsdb_idl_table_class icnbrec_table_classes[ICNBREC_N_TABLES] = {
    {"Connection", false, false,
     icnbrec_connection_columns, ARRAY_SIZE(icnbrec_connection_columns),
     sizeof(struct icnbrec_connection), icnbrec_connection_init__},
    {"IC_NB_Global", true, true,
     icnbrec_ic_nb_global_columns, ARRAY_SIZE(icnbrec_ic_nb_global_columns),
     sizeof(struct icnbrec_ic_nb_global), icnbrec_ic_nb_global_init__},
    {"SSL", false, true,
     icnbrec_ssl_columns, ARRAY_SIZE(icnbrec_ssl_columns),
     sizeof(struct icnbrec_ssl), icnbrec_ssl_init__},
    {"Transit_Switch", true, false,
     icnbrec_transit_switch_columns, ARRAY_SIZE(icnbrec_transit_switch_columns),
     sizeof(struct icnbrec_transit_switch), icnbrec_transit_switch_init__},
};

struct ovsdb_idl_class icnbrec_idl_class = {
    "OVN_IC_Northbound", icnbrec_table_classes, ARRAY_SIZE(icnbrec_table_classes)
};

/* Return the schema version.  The caller must not free the returned value. */
const char *
icnbrec_get_db_version(void)
{
    return "1.1.0";
}

